'From Squeak3.7alpha of 11 September 2003 [latest update: #5707] on 27 February 2004 at 5:18:23 pm'!
"Change Set:		ColoredChangeSorter
Date:			25 February 2004
Author:			Masashi Umezawa

Adds color listing support to ChangeSorter. (for 3.7a)

#remove -> red
#addedThenRemoved -> orange
#add -> blue
#change -> dark cyan 

"!


!ChangeSet methodsFor: 'accessing' stamp: 'MU 8/7/2002 18:15'!
changeRecords
	^changeRecords! !


!ChangeSorter methodsFor: 'creation' stamp: 'mu 2/25/2004 19:46'!
openAsMorphIn: window rect: rect
	"Add a set of change sorter views to the given top view offset by the given amount. To create a single change sorter, call this once with an offset of 0@0. To create a dual change sorter, call it twice with offsets of 0@0 and 0.5@0."

	| csListHeight msgListHeight csMsgListHeight classListMorph messageList |
	contents _ ''.
	csListHeight _ 0.25.
	msgListHeight _ 0.25.
	csMsgListHeight _ csListHeight + msgListHeight.
	self addDependent: window.		"so it will get changed: #relabel"

	window addMorph: ((PluggableListMorphByItem on: self
				list: #changeSetList
				selected: #currentCngSet
				changeSelected: #showChangeSetNamed:
				menu: #changeSetMenu:shifted:
				keystroke: #changeSetListKey:from:)
			autoDeselect: false)
		frame: (((0@0 extent: 0.5@csListHeight)
			scaleBy: rect extent) translateBy: rect origin).

	classListMorph := PluggableListMorphByItem on: self
				list: #classList
				selected: #currentClassName
				changeSelected: #currentClassName:
				menu: #classListMenu:shifted:
				keystroke: #classListKey:from:.
	classListMorph rowColorSelector: #hilightClassRow:. 
	window addMorph: classListMorph
		frame: (((0.5@0 extent: 0.5@csListHeight)
			scaleBy: rect extent) translateBy: rect origin).

	messageList := PluggableListMorphByItem on: self
				list: #messageList
				selected: #currentSelector
				changeSelected: #currentSelector:
				menu: #messageMenu:shifted:
				keystroke: #messageListKey:from:.
	messageList rowColorSelector: #hilightMessageRow:. 
	window addMorph: messageList			
		frame: (((0@csListHeight extent: 1@msgListHeight)
			scaleBy: rect extent) translateBy: rect origin).

	 self addLowerPanesTo: window
		at: (((0@csMsgListHeight corner: 1@1) scaleBy: rect extent) translateBy: rect origin)
		with: nil.! !

!ChangeSorter methodsFor: 'class list' stamp: 'MU 8/7/2002 19:13'!
classChangeStatusColor: selectedClassName 
	| changes |
	changes := myChangeSet classChangeAt: selectedClassName.
	(changes includes: #remove)
		ifTrue: [^ Color red].
	(changes includes: #addedThenRemoved)
		ifTrue: [^ Color orange].
	(changes includes: #add)
		ifTrue: [^ (self existsClass: selectedClassName)
				ifTrue: [Color blue]
				ifFalse: [Color orange]].
	(changes includes: #change)
		ifTrue: [^ (self existsClass: selectedClassName)
				ifTrue: [Color cyan muchDarker]
				ifFalse: [Color orange]].
	^ Color black! !

!ChangeSorter methodsFor: 'message list' stamp: 'MU 8/7/2002 19:20'!
messageChangeStatusColor: selector 
	| changes classChange |
	classChange := myChangeSet changeRecords
				at: currentClassName
				ifAbsent: [].
	classChange isNil
		ifFalse: [changes := classChange
						atSelector: selector
						ifAbsent: [^ Color black].
			changes == #remove
				ifTrue: [^ Color red].
			changes == #addedThenRemoved
				ifTrue: [^ Color orange].
			changes == #add
				ifTrue: [^ (self existsSelector: selector in: currentClassName)
						ifTrue: [Color blue]
						ifFalse: [Color orange]].
			changes == #change
				ifTrue: [^ (self existsSelector: selector in: currentClassName)
						ifTrue: [Color cyan muchDarker]
						ifFalse: [Color orange]]].
	^ Color black! !

!ChangeSorter methodsFor: 'highlighting' stamp: 'mu 2/25/2004 20:08'!
hilightClassRow: item 
	| color changes |
	color := Color black.
	changes := myChangeSet classChangeAt: item.
	(changes includes: #remove)
		ifTrue: [color := Color red].
	(changes includes: #addedThenRemoved)
		ifTrue: [color := Color orange].
	(changes includes: #add)
		ifTrue: [color := (self existsClass: item)
						ifTrue: [Color blue]
						ifFalse: [Color orange]].
	(changes includes: #change)
		ifTrue: [color := (self existsClass: item)
						ifTrue: [Color cyan muchDarker]
						ifFalse: [Color orange]].
	^ color! !

!ChangeSorter methodsFor: 'highlighting' stamp: 'mu 2/25/2004 19:54'!
hilightMessageRow: item 
	| color classChange methodChange |
	color := Color black.
	classChange := myChangeSet changeRecords
				at: currentClassName
				ifAbsent: [].
	methodChange := classChange
				atSelector: item
				ifAbsent: [].
	methodChange isNil
		ifFalse: [methodChange == #remove
				ifTrue: [color := Color red].
			methodChange == #addedThenRemoved
				ifTrue: [color := Color orange].
			methodChange == #add
				ifTrue: [color := (self existsSelector: item in: currentClassName)
								ifTrue: [Color blue]
								ifFalse: [Color orange]].
			methodChange == #change
				ifTrue: [color := (self existsSelector: item in: currentClassName)
								ifTrue: [Color cyan muchDarker]
								ifFalse: [Color orange]]].
	^ color! !

!ChangeSorter methodsFor: 'private' stamp: 'MU 8/7/2002 19:18'!
classOrMetaclassNamed: classOrMetaclassName 
	classOrMetaclassName
		ifNil: [^ nil].
	(classOrMetaclassName endsWith: ' class')
		ifTrue: [| cls | 
			cls := Smalltalk
						at: (classOrMetaclassName copyFrom: 1 to: classOrMetaclassName size - 6) asSymbol
						ifAbsent: [].
			^ cls isNil
				ifFalse: [cls class]]
		ifFalse: [^ Smalltalk
				at: classOrMetaclassName asSymbol
				ifAbsent: []]! !

!ChangeSorter methodsFor: 'private' stamp: 'MU 8/7/2002 19:19'!
existsClass: classOrMetaclassName 
	^(self classOrMetaclassNamed: classOrMetaclassName) notNil! !

!ChangeSorter methodsFor: 'private' stamp: 'MU 8/7/2002 19:31'!
existsSelector: selector in: classOrMetaclassName 
	^(self existsClass: classOrMetaclassName)
		and: [| class | 
			class := self classOrMetaclassNamed: classOrMetaclassName.
			class includesSelector: selector]! !

